
PLUGINDIR = "GaluhadPlugins.StoreAssistant";
RESOURCEDIR = "GaluhadPlugins/StoreAssistant/Resources/";
PLUGINNAME = "Store Assistant";

-- Turbine Imports..
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

-- Plugin Imports..
import (PLUGINDIR..".Globals");
import (PLUGINDIR..".Images");
import (PLUGINDIR..".AddCallBack");
import (PLUGINDIR..".Functions");
import (PLUGINDIR..".Commands");
import (PLUGINDIR..".VindarPatch");

-- Utils Imports..
import (PLUGINDIR..".Utils");

-- Windows..
import (PLUGINDIR..".Windows");

-- Plugin-specific ...
import (PLUGINDIR..".Points");

-----------------------------------------------------------------------------------------------------------

function saveData()
	PatchDataSave(Turbine.DataScope.Account, "store_assistant", SETTINGS);
end


function loadData()
	---------------------------------------------------------------------------------------------------------------------------------
	-- SAVED SETTINGS --
	local SavedSettings = {};

	function GetSavedSettings()
		SavedSettings = PatchDataLoad(Turbine.DataScope.Account, "store_assistant");
	end

	if pcall(GetSavedSettings) then
		GetSavedSettings();
	else -- Loaded with errors
		SavedSettings = nil;
		printError(GetString(1));
	end

	-- Check the saved settings to make sure it is still compatible with newer updates, add in any missing default settings
	if type(SavedSettings) == 'table' then
		local tempSETTINGS = {};
		tempSETTINGS = Utils.deepcopy(DEFAULT_SETTINGS);
		SETTINGS = Utils.mergeTables(tempSETTINGS,SavedSettings);
	else
		SETTINGS = Utils.deepcopy(DEFAULT_SETTINGS);
	end
	----------------------------------------------------------------------------------------------------------------------------------
end


function print(MESSAGE)
	if MESSAGE == nil then return end;
	Turbine.Shell.WriteLine("<rgb=#FF6666>" .. tostring(MESSAGE) .. "</rgb>");
end


function printError(STRING)
	if STRING == nil or STRING == "" then return end;
	Turbine.Shell.WriteLine("<rgb=#FF3333>"..PLUGINNAME..": " .. tostring(STRING) .. "\n" .. GetString(2) .. "</rgb>");
end


function LoadStrings()
	LANGID = Utils.GetClientLanguage();
	_STRINGS = {};
	import (PLUGINDIR..".Strings");
end


function LoadSequence()
	LoadStrings();
	loadData();
	--VerifyData();
	--Utils.InitiateChatLogger();
	Windows.DrawWindows();
	RegisterCommands();
	Turbine.Plugin.Unload = function ()
		saveData();
	end
	print("Loaded '" .. PLUGINNAME .. "' by Galuhad [Evernight]");
	print("With thanks to Darvothil [Brandywine] and Ellins [Evernight]");
	print(GetString(3));
end


-- Initiate load sequence
LoadSequence();
